diff --git a/src/dblib/unittests/t0001.sql b/src/dblib/unittests/t0001.sql
new file mode 100644
index 0000000..c872736
--- /dev/null
+++ b/src/dblib/unittests/t0001.sql
@@ -0,0 +1,105 @@
+create table #dblib0001 (i int not null, s char(10) not null)
+go
+insert into #dblib0001 values (0, "row 000")
+go
+insert into #dblib0001 values (1, "row 001")
+go
+insert into #dblib0001 values (2, "row 002")
+go
+insert into #dblib0001 values (3, "row 003")
+go
+insert into #dblib0001 values (4, "row 004")
+go
+insert into #dblib0001 values (5, "row 005")
+go
+insert into #dblib0001 values (6, "row 006")
+go
+insert into #dblib0001 values (7, "row 007")
+go
+insert into #dblib0001 values (8, "row 008")
+go
+insert into #dblib0001 values (9, "row 009")
+go
+insert into #dblib0001 values (10, "row 010")
+go
+insert into #dblib0001 values (11, "row 011")
+go
+insert into #dblib0001 values (12, "row 012")
+go
+insert into #dblib0001 values (13, "row 013")
+go
+insert into #dblib0001 values (14, "row 014")
+go
+insert into #dblib0001 values (15, "row 015")
+go
+insert into #dblib0001 values (16, "row 016")
+go
+insert into #dblib0001 values (17, "row 017")
+go
+insert into #dblib0001 values (18, "row 018")
+go
+insert into #dblib0001 values (19, "row 019")
+go
+insert into #dblib0001 values (20, "row 020")
+go
+insert into #dblib0001 values (21, "row 021")
+go
+insert into #dblib0001 values (22, "row 022")
+go
+insert into #dblib0001 values (23, "row 023")
+go
+insert into #dblib0001 values (24, "row 024")
+go
+insert into #dblib0001 values (25, "row 025")
+go
+insert into #dblib0001 values (26, "row 026")
+go
+insert into #dblib0001 values (27, "row 027")
+go
+insert into #dblib0001 values (28, "row 028")
+go
+insert into #dblib0001 values (29, "row 029")
+go
+insert into #dblib0001 values (30, "row 030")
+go
+insert into #dblib0001 values (31, "row 031")
+go
+insert into #dblib0001 values (32, "row 032")
+go
+insert into #dblib0001 values (33, "row 033")
+go
+insert into #dblib0001 values (34, "row 034")
+go
+insert into #dblib0001 values (35, "row 035")
+go
+insert into #dblib0001 values (36, "row 036")
+go
+insert into #dblib0001 values (37, "row 037")
+go
+insert into #dblib0001 values (38, "row 038")
+go
+insert into #dblib0001 values (39, "row 039")
+go
+insert into #dblib0001 values (40, "row 040")
+go
+insert into #dblib0001 values (41, "row 041")
+go
+insert into #dblib0001 values (42, "row 042")
+go
+insert into #dblib0001 values (43, "row 043")
+go
+insert into #dblib0001 values (44, "row 044")
+go
+insert into #dblib0001 values (45, "row 045")
+go
+insert into #dblib0001 values (46, "row 046")
+go
+insert into #dblib0001 values (47, "row 047")
+go
+insert into #dblib0001 values (48, "row 048")
+go
+insert into #dblib0001 values (49, "row 049")
+go
+select * from #dblib0001 order by i
+go
+/* dbclose() at Sat Jan 31 21:36:54 2009 */
diff --git a/src/dblib/unittests/t0002.c b/src/dblib/unittests/t0002.c
index e5a3474..7f65bc1 100644
--- a/src/dblib/unittests/t0002.c
+++ b/src/dblib/unittests/t0002.c
@@ -10,7 +10,7 @@
 #include "common.h"
 #include <assert.h>
 
-static char software_version[] = "$Id: t0002.c,v 1.22 2008/11/25 22:58:29 jklowden Exp $";
+static char software_version[] = "$Id: t0002.c,v 1.23 2009/02/01 22:29:39 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int failed = 0;
@@ -47,11 +47,6 @@ main(int argc, char **argv)
 
 	const int buffer_count = 10;
 	const int rows_to_add = 50;
-	const char tablename[] = "#dblib0002";
-	const char drop_if_exists[] = "if exists ( select 1 "
-						  "from tempdb..sysobjects "
-						  "where id = object_id('tempdb..%s') )\n"
-				      "\tdrop table %s\n";
 
 	set_malloc_options();
 
@@ -94,8 +89,7 @@ main(int argc, char **argv)
 	add_bread_crumb();
 
 	add_bread_crumb();
-	fprintf(stdout, drop_if_exists, tablename, tablename);
-	dbfcmd(dbproc,  drop_if_exists, tablename, tablename);
+	sql_cmd(dbproc,  INPUT); /* drop table if exists */
 	add_bread_crumb();
 	dbsqlexec(dbproc);
 	add_bread_crumb();
@@ -108,32 +102,24 @@ main(int argc, char **argv)
 	}
 	add_bread_crumb();
 
-	fprintf(stdout, "create table %s (i int not null, s char(10) not null)\n", tablename);
-	dbfcmd(dbproc,  "create table %s (i int not null, s char(10) not null)", tablename);
+	sql_cmd(dbproc,  INPUT); /* create table */
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) != NO_MORE_RESULTS) {
 		/* nop */
 	}
 
-	fprintf(stdout, "insert into %s [%d rows]\n", tablename, rows_to_add);
 	for (i = 1; i <= rows_to_add; i++) {
-	char cmd[1024];
-
-		sprintf(cmd, "insert into %s values (%d, 'row %03d')", tablename, i, i);
-		dbcmd(dbproc, cmd);
+		sql_cmd(dbproc, INPUT);
 		dbsqlexec(dbproc);
 		while (dbresults(dbproc) != NO_MORE_RESULTS) {
 			/* nop */
 		}
 	}
 
-	fprintf(stdout, "select * from %s order by i\n", tablename);
-	dbfcmd(dbproc,  "select * from %s order by i\n", tablename);
-	dbfcmd(dbproc,  "select * from %s order by i\n", tablename);	/* two result sets */
+	sql_cmd(dbproc, INPUT);	/* two result sets */
 	dbsqlexec(dbproc);
 	add_bread_crumb();
 
-
 	for (iresults=1; iresults <= 2; iresults++ ) {
 		fprintf(stdout, "fetching resultset %i\n", iresults);
 		if (dbresults(dbproc) != SUCCEED) {
@@ -257,7 +243,7 @@ main(int argc, char **argv)
 	dbexit();
 	add_bread_crumb();
 
-	fprintf(stdout, "dblib %s on %s\n", (failed ? "failed!" : "okay"), __FILE__);
+	fprintf(stdout, "%s %s\n", __FILE__, (failed ? "failed!" : "OK"));
 	free_bread_crumb();
 	return failed ? 1 : 0;
 }
diff --git a/src/dblib/unittests/t0002.sql b/src/dblib/unittests/t0002.sql
new file mode 100644
index 0000000..1c96f38
--- /dev/null
+++ b/src/dblib/unittests/t0002.sql
@@ -0,0 +1,109 @@
+if exists ( select 1 from tempdb..sysobjects where id = object_id('tempdb..#dblib0002') )
+	drop table #dblib0002
+
+go
+create table #dblib0002 (i int not null, s char(10) not null)
+go
+insert into #dblib0002 values (1, 'row 001')
+go
+insert into #dblib0002 values (2, 'row 002')
+go
+insert into #dblib0002 values (3, 'row 003')
+go
+insert into #dblib0002 values (4, 'row 004')
+go
+insert into #dblib0002 values (5, 'row 005')
+go
+insert into #dblib0002 values (6, 'row 006')
+go
+insert into #dblib0002 values (7, 'row 007')
+go
+insert into #dblib0002 values (8, 'row 008')
+go
+insert into #dblib0002 values (9, 'row 009')
+go
+insert into #dblib0002 values (10, 'row 010')
+go
+insert into #dblib0002 values (11, 'row 011')
+go
+insert into #dblib0002 values (12, 'row 012')
+go
+insert into #dblib0002 values (13, 'row 013')
+go
+insert into #dblib0002 values (14, 'row 014')
+go
+insert into #dblib0002 values (15, 'row 015')
+go
+insert into #dblib0002 values (16, 'row 016')
+go
+insert into #dblib0002 values (17, 'row 017')
+go
+insert into #dblib0002 values (18, 'row 018')
+go
+insert into #dblib0002 values (19, 'row 019')
+go
+insert into #dblib0002 values (20, 'row 020')
+go
+insert into #dblib0002 values (21, 'row 021')
+go
+insert into #dblib0002 values (22, 'row 022')
+go
+insert into #dblib0002 values (23, 'row 023')
+go
+insert into #dblib0002 values (24, 'row 024')
+go
+insert into #dblib0002 values (25, 'row 025')
+go
+insert into #dblib0002 values (26, 'row 026')
+go
+insert into #dblib0002 values (27, 'row 027')
+go
+insert into #dblib0002 values (28, 'row 028')
+go
+insert into #dblib0002 values (29, 'row 029')
+go
+insert into #dblib0002 values (30, 'row 030')
+go
+insert into #dblib0002 values (31, 'row 031')
+go
+insert into #dblib0002 values (32, 'row 032')
+go
+insert into #dblib0002 values (33, 'row 033')
+go
+insert into #dblib0002 values (34, 'row 034')
+go
+insert into #dblib0002 values (35, 'row 035')
+go
+insert into #dblib0002 values (36, 'row 036')
+go
+insert into #dblib0002 values (37, 'row 037')
+go
+insert into #dblib0002 values (38, 'row 038')
+go
+insert into #dblib0002 values (39, 'row 039')
+go
+insert into #dblib0002 values (40, 'row 040')
+go
+insert into #dblib0002 values (41, 'row 041')
+go
+insert into #dblib0002 values (42, 'row 042')
+go
+insert into #dblib0002 values (43, 'row 043')
+go
+insert into #dblib0002 values (44, 'row 044')
+go
+insert into #dblib0002 values (45, 'row 045')
+go
+insert into #dblib0002 values (46, 'row 046')
+go
+insert into #dblib0002 values (47, 'row 047')
+go
+insert into #dblib0002 values (48, 'row 048')
+go
+insert into #dblib0002 values (49, 'row 049')
+go
+insert into #dblib0002 values (50, 'row 050')
+go
+select * from #dblib0002 order by i
+select * from #dblib0002 order by i
+go
diff --git a/src/dblib/unittests/t0003.c b/src/dblib/unittests/t0003.c
index 98b444d..4d9dcc5 100644
--- a/src/dblib/unittests/t0003.c
+++ b/src/dblib/unittests/t0003.c
@@ -5,7 +5,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: t0003.c,v 1.14 2008/11/25 22:58:29 jklowden Exp $";
+static char software_version[] = "$Id: t0003.c,v 1.15 2009/02/01 22:29:39 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 
@@ -65,7 +65,7 @@ main(int argc, char **argv)
 	add_bread_crumb();
 
 	fprintf(stdout, "creating table\n");
-	dbcmd(dbproc, "create table #dblib0003 (i int not null, s char(10) not null)");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) != NO_MORE_RESULTS) {
 		/* nop */
@@ -73,10 +73,7 @@ main(int argc, char **argv)
 
 	fprintf(stdout, "insert\n");
 	for (i = 1; i < rows_to_add; i++) {
-	char cmd[1024];
-
-		sprintf(cmd, "insert into #dblib0003 values (%d, 'row %03d')", i, i);
-		dbcmd(dbproc, cmd);
+		sql_cmd(dbproc, INPUT);
 		dbsqlexec(dbproc);
 		while (dbresults(dbproc) != NO_MORE_RESULTS) {
 			/* nop */
@@ -84,7 +81,7 @@ main(int argc, char **argv)
 	}
 
 	fprintf(stdout, "select\n");
-	dbcmd(dbproc, "select * from #dblib0003 order by i");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	add_bread_crumb();
 
@@ -156,7 +153,7 @@ main(int argc, char **argv)
 	dbexit();
 	add_bread_crumb();
 
-	fprintf(stdout, "dblib %s on %s\n", (failed ? "failed!" : "okay"), __FILE__);
+	fprintf(stdout, "%s %s\n", __FILE__, (failed ? "failed!" : "OK"));
 	free_bread_crumb();
 	return failed ? 1 : 0;
 }
diff --git a/src/dblib/unittests/t0003.sql b/src/dblib/unittests/t0003.sql
new file mode 100644
index 0000000..91fdb6a
--- /dev/null
+++ b/src/dblib/unittests/t0003.sql
@@ -0,0 +1,102 @@
+create table #dblib0003 (i int not null, s char(10) not null)
+go
+insert into #dblib0003 values (1, 'row 001')
+go
+insert into #dblib0003 values (2, 'row 002')
+go
+insert into #dblib0003 values (3, 'row 003')
+go
+insert into #dblib0003 values (4, 'row 004')
+go
+insert into #dblib0003 values (5, 'row 005')
+go
+insert into #dblib0003 values (6, 'row 006')
+go
+insert into #dblib0003 values (7, 'row 007')
+go
+insert into #dblib0003 values (8, 'row 008')
+go
+insert into #dblib0003 values (9, 'row 009')
+go
+insert into #dblib0003 values (10, 'row 010')
+go
+insert into #dblib0003 values (11, 'row 011')
+go
+insert into #dblib0003 values (12, 'row 012')
+go
+insert into #dblib0003 values (13, 'row 013')
+go
+insert into #dblib0003 values (14, 'row 014')
+go
+insert into #dblib0003 values (15, 'row 015')
+go
+insert into #dblib0003 values (16, 'row 016')
+go
+insert into #dblib0003 values (17, 'row 017')
+go
+insert into #dblib0003 values (18, 'row 018')
+go
+insert into #dblib0003 values (19, 'row 019')
+go
+insert into #dblib0003 values (20, 'row 020')
+go
+insert into #dblib0003 values (21, 'row 021')
+go
+insert into #dblib0003 values (22, 'row 022')
+go
+insert into #dblib0003 values (23, 'row 023')
+go
+insert into #dblib0003 values (24, 'row 024')
+go
+insert into #dblib0003 values (25, 'row 025')
+go
+insert into #dblib0003 values (26, 'row 026')
+go
+insert into #dblib0003 values (27, 'row 027')
+go
+insert into #dblib0003 values (28, 'row 028')
+go
+insert into #dblib0003 values (29, 'row 029')
+go
+insert into #dblib0003 values (30, 'row 030')
+go
+insert into #dblib0003 values (31, 'row 031')
+go
+insert into #dblib0003 values (32, 'row 032')
+go
+insert into #dblib0003 values (33, 'row 033')
+go
+insert into #dblib0003 values (34, 'row 034')
+go
+insert into #dblib0003 values (35, 'row 035')
+go
+insert into #dblib0003 values (36, 'row 036')
+go
+insert into #dblib0003 values (37, 'row 037')
+go
+insert into #dblib0003 values (38, 'row 038')
+go
+insert into #dblib0003 values (39, 'row 039')
+go
+insert into #dblib0003 values (40, 'row 040')
+go
+insert into #dblib0003 values (41, 'row 041')
+go
+insert into #dblib0003 values (42, 'row 042')
+go
+insert into #dblib0003 values (43, 'row 043')
+go
+insert into #dblib0003 values (44, 'row 044')
+go
+insert into #dblib0003 values (45, 'row 045')
+go
+insert into #dblib0003 values (46, 'row 046')
+go
+insert into #dblib0003 values (47, 'row 047')
+go
+insert into #dblib0003 values (48, 'row 048')
+go
+insert into #dblib0003 values (49, 'row 049')
+go
+select * from #dblib0003 order by i
+go
diff --git a/src/dblib/unittests/t0004.c b/src/dblib/unittests/t0004.c
index ea06e9e..48aa4a1 100644
--- a/src/dblib/unittests/t0004.c
+++ b/src/dblib/unittests/t0004.c
@@ -6,7 +6,7 @@
 #include "common.h"
 
 
-static char software_version[] = "$Id: t0004.c,v 1.17 2008/11/25 22:58:29 jklowden Exp $";
+static char software_version[] = "$Id: t0004.c,v 1.18 2009/02/01 22:29:39 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 
@@ -14,7 +14,6 @@ static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 int
 main(int argc, char **argv)
 {
-	char cmd[1024];
 	const int rows_to_add = 50;
 	LOGINREC *login;
 	DBPROCESS *dbproc;
@@ -57,7 +56,7 @@ main(int argc, char **argv)
 	add_bread_crumb();
 
 	fprintf(stdout, "creating table\n");
-	dbcmd(dbproc, "create table #dblib0004 (i int not null, s char(10) not null)");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) != NO_MORE_RESULTS) {
 		/* nop */
@@ -65,18 +64,14 @@ main(int argc, char **argv)
 
 	fprintf(stdout, "insert\n");
 	for (i = 1; i < rows_to_add; i++) {
-		sprintf(cmd, "insert into #dblib0004 values (%d, 'row %04d')", i, i);
-		fprintf(stdout, "%s\n", cmd);
-		dbcmd(dbproc, cmd);
+		sql_cmd(dbproc, INPUT);
 		dbsqlexec(dbproc);
 		while (dbresults(dbproc) != NO_MORE_RESULTS) {
 			/* nop */
 		}
 	}
 
-	sprintf(cmd, "select * from #dblib0004 where i<=25 order by i");
-	fprintf(stdout, "%s\n", cmd);
-	dbcmd(dbproc, cmd);
+	sql_cmd(dbproc, INPUT); /* select */
 	dbsqlexec(dbproc);
 	add_bread_crumb();
 
@@ -138,9 +133,7 @@ main(int argc, char **argv)
 
 	fprintf(stdout, "second select\n");
 
-	sprintf(cmd, "select * from #dblib0004 where i>950 order by i");
-	fprintf(stdout, "%s\n", cmd);
-	if (SUCCEED != dbcmd(dbproc, cmd)) {
+	if (SUCCEED != sql_cmd(dbproc, INPUT)) {
 		fprintf(stderr, "%s:%d: dbcmd failed\n", __FILE__, __LINE__);
 		failed = 1;
 	}
@@ -155,7 +148,7 @@ main(int argc, char **argv)
 	dbexit();
 	add_bread_crumb();
 
-	fprintf(stdout, "dblib %s on %s\n", (failed ? "failed!" : "okay"), __FILE__);
+	fprintf(stdout, "%s %s\n", __FILE__, (failed ? "failed!" : "OK"));
 	free_bread_crumb();
 	return failed ? 1 : 0;
 }
diff --git a/src/dblib/unittests/t0004.sql b/src/dblib/unittests/t0004.sql
new file mode 100644
index 0000000..22c13c8
--- /dev/null
+++ b/src/dblib/unittests/t0004.sql
@@ -0,0 +1,108 @@
+create table #dblib0004 (i int not null, s char(10) not null)
+go
+insert into #dblib0004 values (1, 'row 0001')
+go
+insert into #dblib0004 values (2, 'row 0002')
+go
+insert into #dblib0004 values (3, 'row 0003')
+go
+insert into #dblib0004 values (4, 'row 0004')
+go
+insert into #dblib0004 values (5, 'row 0005')
+go
+insert into #dblib0004 values (6, 'row 0006')
+go
+insert into #dblib0004 values (7, 'row 0007')
+go
+insert into #dblib0004 values (8, 'row 0008')
+go
+insert into #dblib0004 values (9, 'row 0009')
+go
+insert into #dblib0004 values (10, 'row 0010')
+go
+insert into #dblib0004 values (11, 'row 0011')
+go
+insert into #dblib0004 values (12, 'row 0012')
+go
+insert into #dblib0004 values (13, 'row 0013')
+go
+insert into #dblib0004 values (14, 'row 0014')
+go
+insert into #dblib0004 values (15, 'row 0015')
+go
+insert into #dblib0004 values (16, 'row 0016')
+go
+insert into #dblib0004 values (17, 'row 0017')
+go
+insert into #dblib0004 values (18, 'row 0018')
+go
+insert into #dblib0004 values (19, 'row 0019')
+go
+insert into #dblib0004 values (20, 'row 0020')
+go
+insert into #dblib0004 values (21, 'row 0021')
+go
+insert into #dblib0004 values (22, 'row 0022')
+go
+insert into #dblib0004 values (23, 'row 0023')
+go
+insert into #dblib0004 values (24, 'row 0024')
+go
+insert into #dblib0004 values (25, 'row 0025')
+go
+insert into #dblib0004 values (26, 'row 0026')
+go
+insert into #dblib0004 values (27, 'row 0027')
+go
+insert into #dblib0004 values (28, 'row 0028')
+go
+insert into #dblib0004 values (29, 'row 0029')
+go
+insert into #dblib0004 values (30, 'row 0030')
+go
+insert into #dblib0004 values (31, 'row 0031')
+go
+insert into #dblib0004 values (32, 'row 0032')
+go
+insert into #dblib0004 values (33, 'row 0033')
+go
+insert into #dblib0004 values (34, 'row 0034')
+go
+insert into #dblib0004 values (35, 'row 0035')
+go
+insert into #dblib0004 values (36, 'row 0036')
+go
+insert into #dblib0004 values (37, 'row 0037')
+go
+insert into #dblib0004 values (38, 'row 0038')
+go
+insert into #dblib0004 values (39, 'row 0039')
+go
+insert into #dblib0004 values (40, 'row 0040')
+go
+insert into #dblib0004 values (41, 'row 0041')
+go
+insert into #dblib0004 values (42, 'row 0042')
+go
+insert into #dblib0004 values (43, 'row 0043')
+go
+insert into #dblib0004 values (44, 'row 0044')
+go
+insert into #dblib0004 values (45, 'row 0045')
+go
+insert into #dblib0004 values (46, 'row 0046')
+go
+insert into #dblib0004 values (47, 'row 0047')
+go
+insert into #dblib0004 values (48, 'row 0048')
+go
+insert into #dblib0004 values (49, 'row 0049')
+go
+select * from #dblib0004 where i<=25 order by i
+go
+/* The following statement fails intentionally: 
+ * the unit test is checking that db-lib returns FAIL
+ * when results have not been fully processed. 
+ */
+select * from #dblib0004 where i<=25 order by i
+go
diff --git a/src/dblib/unittests/t0005.c b/src/dblib/unittests/t0005.c
index 8c24410..ff5b5ad 100644
--- a/src/dblib/unittests/t0005.c
+++ b/src/dblib/unittests/t0005.c
@@ -5,7 +5,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: t0005.c,v 1.24 2008/11/25 22:58:29 jklowden Exp $";
+static char software_version[] = "$Id: t0005.c,v 1.25 2009/02/01 22:29:39 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int
@@ -17,7 +17,6 @@ main(int argc, char **argv)
 	int i;
 	char teststr[1024];
 	DBINT testint;
-	char cmd[1024];
 	int failed = 0;
 	int expected_error;
 
@@ -56,7 +55,7 @@ main(int argc, char **argv)
 	add_bread_crumb();
 
 	fprintf(stdout, "creating table\n");
-	if (SUCCEED != dbcmd(dbproc, "create table #dblib0005 " "(i int not null, s char(10) not null)")) {
+	if (SUCCEED != sql_cmd(dbproc, INPUT)) {
 		fprintf(stderr, "%s:%d: dbcmd failed\n", __FILE__, __LINE__);
 		failed = 1;
 	}
@@ -72,8 +71,7 @@ main(int argc, char **argv)
 
 	fprintf(stdout, "insert\n");
 	for (i = 1; i < rows_to_add; i++) {
-		sprintf(cmd, "insert into #dblib0005 values (%d, 'row %04d')", i, i);
-		dbcmd(dbproc, cmd);
+		sql_cmd(dbproc, INPUT);
 		dbsqlexec(dbproc);
 		while (dbresults(dbproc) != NO_MORE_RESULTS) {
 			/* nop */
@@ -81,9 +79,7 @@ main(int argc, char **argv)
 	}
 
 
-	sprintf(cmd, "select * from #dblib0005 where i < 5 order by i");
-	fprintf(stdout, "%s\n", cmd);
-	dbcmd(dbproc, cmd);
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	add_bread_crumb();
 
@@ -140,13 +136,10 @@ main(int argc, char **argv)
 	fprintf(stdout, "This query should succeeded as we have fetched the exact\n"
 			"number of rows in the result set\n");
 
-	sprintf(cmd, "select * from #dblib0005 where i < 6 order by i");
-	fprintf(stdout, "%s\n", cmd);
-	
 	expected_error = 20019;
 	dbsetuserdata(dbproc, (BYTE*) &expected_error);
 
-	if (SUCCEED != dbcmd(dbproc, cmd)) {
+	if (SUCCEED != sql_cmd(dbproc, INPUT)) {
 		fprintf(stderr, "%s:%d: dbcmd failed\n", __FILE__, __LINE__);
 		failed = 1;
 	}
@@ -205,12 +198,9 @@ main(int argc, char **argv)
 		printf("Read a row of data -> %d %s\n", (int) testint, teststr);
 	}
 
-	fprintf(stdout, "This query should fail as we have not fetched all the\n");
-	fprintf(stdout, "rows in the result set\n");
+	fprintf(stdout, "Testing anticipated failure\n");
 
-	sprintf(cmd, "select * from #dblib0005 where i > 950 order by i");
-	fprintf(stdout, "%s\n", cmd);
-	if (SUCCEED != dbcmd(dbproc, cmd)) {
+	if (SUCCEED != sql_cmd(dbproc, INPUT)) {
 		fprintf(stderr, "%s:%d: dbcmd failed\n", __FILE__, __LINE__);
 		failed = 1;
 	}
@@ -225,8 +215,7 @@ main(int argc, char **argv)
 
 	fprintf(stdout, "Dropping proc\n");
 	add_bread_crumb();
-	sprintf(cmd, "if object_id('t0005_proc') is not null drop procedure t0005_proc");
-	dbcmd(dbproc, cmd);
+	sql_cmd(dbproc, INPUT);
 	add_bread_crumb();
 	dbsqlexec(dbproc);
 	add_bread_crumb();
@@ -236,12 +225,7 @@ main(int argc, char **argv)
 	add_bread_crumb();
 
 	fprintf(stdout, "creating proc\n");
-	sprintf(cmd, "create proc t0005_proc (@b int out) as\nbegin\n"
-		"select * from #dblib0005 where i < 6 order by i\n" "select @b = 42\n" "end\n");
-
-	fprintf(stdout, "%s\n", cmd);
-
-	dbcmd(dbproc, cmd);
+	sql_cmd(dbproc, INPUT);
 	if (dbsqlexec(dbproc) == FAIL) {
 		add_bread_crumb();
 		fprintf(stderr, "%s:%d: failed to create procedure\n", __FILE__, __LINE__);
@@ -252,10 +236,7 @@ main(int argc, char **argv)
 	}
 
 	fprintf(stdout, "calling proc\n");
-	sprintf(cmd, "declare @myout int exec t0005_proc @b = @myout output");
-	fprintf(stdout, "%s\n", cmd);
-
-	dbcmd(dbproc, cmd);
+	sql_cmd(dbproc, INPUT);
 	if (dbsqlexec(dbproc) == FAIL) {
 		add_bread_crumb();
 		fprintf(stderr, "%s:%d: failed to call procedure\n", __FILE__, __LINE__);
@@ -309,12 +290,11 @@ main(int argc, char **argv)
 	}
 	add_bread_crumb();
 
-	fprintf(stdout, "This next command should succeed as we have fetched the exact\n"
-			"number of rows in the result set\n");
+	fprintf(stdout, "Calling dbsqlexec before dbnextrow returns NO_MORE_ROWS\n");
+	fprintf(stdout, "The following command should succeed because\n"
+			"we have fetched the exact number of rows in the result set\n");
 
-	sprintf(cmd, "select getdate()");
-	fprintf(stdout, "%s\n", cmd);
-	if (SUCCEED != dbcmd(dbproc, cmd)) {
+	if (SUCCEED != sql_cmd(dbproc, INPUT)) {
 		fprintf(stderr, "%s:%d: dbcmd failed\n", __FILE__, __LINE__);
 		failed = 1;
 	}
@@ -326,7 +306,7 @@ main(int argc, char **argv)
 
 	dbcancel(dbproc);
 
-	dbcmd(dbproc, "drop procedure t0005_proc");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) != NO_MORE_RESULTS) {
 		/* nop */
@@ -335,7 +315,7 @@ main(int argc, char **argv)
 	dbexit();
 	add_bread_crumb();
 
-	fprintf(stdout, "dblib %s on %s\n", (failed ? "failed!" : "okay"), __FILE__);
+	fprintf(stdout, "%s %s\n", __FILE__, (failed ? "failed!" : "OK"));
 	free_bread_crumb();
 	return failed ? 1 : 0;
 }
diff --git a/src/dblib/unittests/t0005.sql b/src/dblib/unittests/t0005.sql
new file mode 100644
index 0000000..58a3896
--- /dev/null
+++ b/src/dblib/unittests/t0005.sql
@@ -0,0 +1,125 @@
+create table #dblib0005 (i int not null, s char(10) not null)
+go
+insert into #dblib0005 values (1, 'row 0001')
+go
+insert into #dblib0005 values (2, 'row 0002')
+go
+insert into #dblib0005 values (3, 'row 0003')
+go
+insert into #dblib0005 values (4, 'row 0004')
+go
+insert into #dblib0005 values (5, 'row 0005')
+go
+insert into #dblib0005 values (6, 'row 0006')
+go
+insert into #dblib0005 values (7, 'row 0007')
+go
+insert into #dblib0005 values (8, 'row 0008')
+go
+insert into #dblib0005 values (9, 'row 0009')
+go
+insert into #dblib0005 values (10, 'row 0010')
+go
+insert into #dblib0005 values (11, 'row 0011')
+go
+insert into #dblib0005 values (12, 'row 0012')
+go
+insert into #dblib0005 values (13, 'row 0013')
+go
+insert into #dblib0005 values (14, 'row 0014')
+go
+insert into #dblib0005 values (15, 'row 0015')
+go
+insert into #dblib0005 values (16, 'row 0016')
+go
+insert into #dblib0005 values (17, 'row 0017')
+go
+insert into #dblib0005 values (18, 'row 0018')
+go
+insert into #dblib0005 values (19, 'row 0019')
+go
+insert into #dblib0005 values (20, 'row 0020')
+go
+insert into #dblib0005 values (21, 'row 0021')
+go
+insert into #dblib0005 values (22, 'row 0022')
+go
+insert into #dblib0005 values (23, 'row 0023')
+go
+insert into #dblib0005 values (24, 'row 0024')
+go
+insert into #dblib0005 values (25, 'row 0025')
+go
+insert into #dblib0005 values (26, 'row 0026')
+go
+insert into #dblib0005 values (27, 'row 0027')
+go
+insert into #dblib0005 values (28, 'row 0028')
+go
+insert into #dblib0005 values (29, 'row 0029')
+go
+insert into #dblib0005 values (30, 'row 0030')
+go
+insert into #dblib0005 values (31, 'row 0031')
+go
+insert into #dblib0005 values (32, 'row 0032')
+go
+insert into #dblib0005 values (33, 'row 0033')
+go
+insert into #dblib0005 values (34, 'row 0034')
+go
+insert into #dblib0005 values (35, 'row 0035')
+go
+insert into #dblib0005 values (36, 'row 0036')
+go
+insert into #dblib0005 values (37, 'row 0037')
+go
+insert into #dblib0005 values (38, 'row 0038')
+go
+insert into #dblib0005 values (39, 'row 0039')
+go
+insert into #dblib0005 values (40, 'row 0040')
+go
+insert into #dblib0005 values (41, 'row 0041')
+go
+insert into #dblib0005 values (42, 'row 0042')
+go
+insert into #dblib0005 values (43, 'row 0043')
+go
+insert into #dblib0005 values (44, 'row 0044')
+go
+insert into #dblib0005 values (45, 'row 0045')
+go
+insert into #dblib0005 values (46, 'row 0046')
+go
+insert into #dblib0005 values (47, 'row 0047')
+go
+insert into #dblib0005 values (48, 'row 0048')
+go
+insert into #dblib0005 values (49, 'row 0049')
+go
+select * from #dblib0005 where i < 5 order by i
+go
+select * from #dblib0005 where i < 6 order by i
+go
+/*
+ * The following query should fail because the test 
+ * has not fetched all the rows in the result set.
+ */
+select * from #dblib0005 where i > 950 order by i
+go
+if object_id('t0005_proc') is not null drop procedure t0005_proc
+go
+create proc t0005_proc (@b int out) as
+begin
+select * from #dblib0005 where i < 6 order by i
+select @b = 42
+end
+
+go
+declare @myout int exec t0005_proc @b = @myout output
+go
+select getdate()
+go
+drop procedure t0005_proc
+go
diff --git a/src/dblib/unittests/t0006.c b/src/dblib/unittests/t0006.c
index 019c177..127ac63 100644
--- a/src/dblib/unittests/t0006.c
+++ b/src/dblib/unittests/t0006.c
@@ -6,7 +6,7 @@
 #include "common.h"
 
 
-static char software_version[] = "$Id: t0006.c,v 1.17 2008/11/25 22:58:29 jklowden Exp $";
+static char software_version[] = "$Id: t0006.c,v 1.18 2009/02/01 22:29:39 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 
@@ -92,7 +92,7 @@ main(int argc, char **argv)
 	add_bread_crumb();
 
 	fprintf(stdout, "creating table\n");
-	dbcmd(dbproc, "create table #dblib0006 (i int not null, s char(10) not null)");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) != NO_MORE_RESULTS) {
 		/* nop */
@@ -100,10 +100,7 @@ main(int argc, char **argv)
 
 	fprintf(stdout, "insert\n");
 	for (i = 1; i < rows_to_add; i++) {
-	char cmd[1024];
-
-		sprintf(cmd, "insert into #dblib0006 values (%d, 'row %04d')", i, i);
-		dbcmd(dbproc, cmd);
+		sql_cmd(dbproc, INPUT);
 		dbsqlexec(dbproc);
 		while (dbresults(dbproc) != NO_MORE_RESULTS) {
 			/* nop */
@@ -111,7 +108,7 @@ main(int argc, char **argv)
 	}
 
 	fprintf(stdout, "first select\n");
-	if (SUCCEED != dbcmd(dbproc, "select * from #dblib0006 where i<50 order by i")) {
+	if (SUCCEED != sql_cmd(dbproc, INPUT)) {
 		fprintf(stderr, "%s:%d: dbcmd failed\n", __FILE__, __LINE__);
 		failed = 1;
 	}
@@ -148,7 +145,7 @@ main(int argc, char **argv)
 	testint = -1;
 	strcpy(teststr, "bogus");
 	fprintf(stdout, "second select\n");
-	dbcmd(dbproc, "select * from #dblib0006 where i>=25 order by i");
+	sql_cmd(dbproc, INPUT);
 	dbsqlexec(dbproc);
 	add_bread_crumb();
 
@@ -174,7 +171,7 @@ main(int argc, char **argv)
 	dbexit();
 	add_bread_crumb();
 
-	fprintf(stdout, "dblib %s on %s\n", (failed ? "failed!" : "okay"), __FILE__);
+	fprintf(stdout, "%s %s\n", __FILE__, (failed ? "failed!" : "OK"));
 	free_bread_crumb();
 	return failed ? 1 : 0;
 }
diff --git a/src/dblib/unittests/t0006.sql b/src/dblib/unittests/t0006.sql
new file mode 100644
index 0000000..0ee11eb
--- /dev/null
+++ b/src/dblib/unittests/t0006.sql
@@ -0,0 +1,104 @@
+create table #dblib0006 (i int not null, s char(10) not null)
+go
+insert into #dblib0006 values (1, 'row 0001')
+go
+insert into #dblib0006 values (2, 'row 0002')
+go
+insert into #dblib0006 values (3, 'row 0003')
+go
+insert into #dblib0006 values (4, 'row 0004')
+go
+insert into #dblib0006 values (5, 'row 0005')
+go
+insert into #dblib0006 values (6, 'row 0006')
+go
+insert into #dblib0006 values (7, 'row 0007')
+go
+insert into #dblib0006 values (8, 'row 0008')
+go
+insert into #dblib0006 values (9, 'row 0009')
+go
+insert into #dblib0006 values (10, 'row 0010')
+go
+insert into #dblib0006 values (11, 'row 0011')
+go
+insert into #dblib0006 values (12, 'row 0012')
+go
+insert into #dblib0006 values (13, 'row 0013')
+go
+insert into #dblib0006 values (14, 'row 0014')
+go
+insert into #dblib0006 values (15, 'row 0015')
+go
+insert into #dblib0006 values (16, 'row 0016')
+go
+insert into #dblib0006 values (17, 'row 0017')
+go
+insert into #dblib0006 values (18, 'row 0018')
+go
+insert into #dblib0006 values (19, 'row 0019')
+go
+insert into #dblib0006 values (20, 'row 0020')
+go
+insert into #dblib0006 values (21, 'row 0021')
+go
+insert into #dblib0006 values (22, 'row 0022')
+go
+insert into #dblib0006 values (23, 'row 0023')
+go
+insert into #dblib0006 values (24, 'row 0024')
+go
+insert into #dblib0006 values (25, 'row 0025')
+go
+insert into #dblib0006 values (26, 'row 0026')
+go
+insert into #dblib0006 values (27, 'row 0027')
+go
+insert into #dblib0006 values (28, 'row 0028')
+go
+insert into #dblib0006 values (29, 'row 0029')
+go
+insert into #dblib0006 values (30, 'row 0030')
+go
+insert into #dblib0006 values (31, 'row 0031')
+go
+insert into #dblib0006 values (32, 'row 0032')
+go
+insert into #dblib0006 values (33, 'row 0033')
+go
+insert into #dblib0006 values (34, 'row 0034')
+go
+insert into #dblib0006 values (35, 'row 0035')
+go
+insert into #dblib0006 values (36, 'row 0036')
+go
+insert into #dblib0006 values (37, 'row 0037')
+go
+insert into #dblib0006 values (38, 'row 0038')
+go
+insert into #dblib0006 values (39, 'row 0039')
+go
+insert into #dblib0006 values (40, 'row 0040')
+go
+insert into #dblib0006 values (41, 'row 0041')
+go
+insert into #dblib0006 values (42, 'row 0042')
+go
+insert into #dblib0006 values (43, 'row 0043')
+go
+insert into #dblib0006 values (44, 'row 0044')
+go
+insert into #dblib0006 values (45, 'row 0045')
+go
+insert into #dblib0006 values (46, 'row 0046')
+go
+insert into #dblib0006 values (47, 'row 0047')
+go
+insert into #dblib0006 values (48, 'row 0048')
+go
+insert into #dblib0006 values (49, 'row 0049')
+go
+select * from #dblib0006 where i<50 order by i
+go
+select * from #dblib0006 where i>=25 order by i
+go
